<?php

function _gmap_direx_get_js() {
  $alert_unknown_address = t('No corresponding geographic location could be found for one of the specified addresses. This may be due to the fact that the address is relatively new, or it may be incorrect. Error code: ');
	$alert_server_error = t('A geocoding or directions request could not be successfully processed, yet the exact reason for the failure is not known. Error code: ');
	$alert_missing_query = t('The HTTP q parameter was either missing or had no value. For geocoder requests, this means that an empty address was specified as input. For directions requests, this means that no query was specified in the input. Error code: ');
	$alert_unavailable_address = t('The geocode for the given address or the route for the given directions query cannot be returned due to legal or contractual reasons. Error code: ');
	$alert_bad_key = t('The given key is either invalid or does not match the domain for which it was given. Error code: ');
	$alert_bad_request = t('A directions request could not be successfully parsed. Error code: ');
	$alert_else = t('An unknown error occurred.');
  $save = t('Save Direction');
  $js = <<<EOT
var map;
var gdir;
var locale;
var geocoder = null;
var addressMarker;

if (!this.JSON) {
  this.JSON = {};
}

function initialize() {
  if (GBrowserIsCompatible()) {
    gdir = new GDirections();
    GEvent.addListener(gdir, "load", onGDirectionsLoad);
    GEvent.addListener(gdir, "error", handleErrors);
  }
}
    
function setDirections(mylocale) {
  locale = mylocale;
  var waypoints = new Array(document.getElementById("edit-from").value);
  var moreFields = true;
  var i = 1;
  while (moreFields) {
    try {
      var v = document.getElementById("edit-via-wp"+i).value;
      if (v.length > 0) {
        waypoints.push(v);
      }
    }
    catch (e) {
      moreFields = false;
    }
    i++;
  }
  waypoints.push(document.getElementById("edit-to").value);
  gdir.loadFromWaypoints(waypoints, { "locale": locale, "getSteps": true, "getPolyline": true });
}

function handleErrors(){
  if (gdir.getStatus().code == G_GEO_UNKNOWN_ADDRESS)
	  alert("$alert_unknown_address" + gdir.getStatus().code);
	else if (gdir.getStatus().code == G_GEO_SERVER_ERROR)
	  alert("$alert_server_error" + gdir.getStatus().code);
	else if (gdir.getStatus().code == G_GEO_MISSING_QUERY)
	  alert("$alert_missing_query" + gdir.getStatus().code);
	else if (gdir.getStatus().code == G_UNAVAILABLE_ADDRESS)
	  alert("$alert_unavailable_address" + gdir.getStatus().code);
	else if (gdir.getStatus().code == G_GEO_BAD_KEY)
	  alert("$alert_bad_key" + gdir.getStatus().code);
	else if (gdir.getStatus().code == G_GEO_BAD_REQUEST)
    alert("$alert_bad_request" + gdir.getStatus().code);
	else alert("$alert_else");
}

function onGDirectionsLoad(){ 
  var res = new Object();
  var numRoutes = gdir.getNumRoutes();
  var numGeocodes = gdir.getNumGeocodes();
  var route = new Object();
  for (var i = 0; i < numRoutes; i++) {
    var ri = gdir.getRoute(i);
    var n = ri.getNumSteps();
    var steps = new Object();
    for (var j = 0; j < n; j++) {
      var rs = ri.getStep(j);
      var step = new Object();
      step['LatLng'] = rs.getLatLng();
      step['Description'] = rs.getDescriptionHtml();
      step['Distance'] = rs.getDistance();
      step['Duration'] = rs.getDuration();
      steps[j] = step;
    }
    route[i] = steps;
  }
  var polyline = gdir.getPolyline();
  var numPoly = polyline.getVertexCount();
  var polysteps = new Object();
  for (var i = 0; i < numPoly; i++) {
    var rs = polyline.getVertex(i);
    var step = new Object();
    step['Lat'] = rs.lat();
    step['Lng'] = rs.lng();
    polysteps[i] = step;
  }
  var geocode = new Object();
  for (var i = 0; i < numGeocodes; i++) {
    geocode[i] = gdir.getGeocode(i);
  }
  res['locale'] = locale;
  res['status'] = gdir.getStatus();
  res['center'] = gdir.getBounds().getCenter();
  res['copyrighthtml'] = gdir.getCopyrightsHtml();
  res['summaryhtml'] = gdir.getSummaryHtml();
  res['distance'] = gdir.getDistance();
  res['duration'] = gdir.getDuration();
  res['polyline'] = polysteps;
  //res['marker'] = marker;
  res['geocode'] = geocode;
  res['route'] = route;
  var output = JSON.stringify(res);
	output = output.replace(/"/g, '#-#');//"
	output = '<form action="/gmap_direx/add/go" accept-charset="UTF-8" method="post" id="directionresult" class="info"><input type="hidden" name="direction" value="'+output+'" /><input type="submit" value="$save"/></div></form>';
	document.getElementById("gmap_direx_result").innerHTML = output;
}

$(document).ready(function(){ initialize();})
$(window).unload(function(){ GUnload();})
EOT;
  return $js;
}

